/* $Id: globdefs.c,v 3.2 1992/03/05 17:38:22 uwe Exp $ */

/* LIGA backend module		*/
/* type, variable declarations	*/
/* U. Kastens, 13. 1. 92	*/

#include "err.h"
#include "global.h"
/*
#include "LIGA.h"
#include "LIGAMacros.h"
*/
#include "ligaconsts.h"
#include "lookup_idl.h"
#include "backptg_gen.h"

#include "globdefs.h"
#include "attrdecl.h"
#include "incl.h"
#include "BackNames.h"

#define _TERMINATOR	 
/*#define _TERMINATOR	,""
old PTG*/

Def	tmpDef;

void TrSeqDef (ae)
	AttrEval	ae;
{	SEQDef		defs;
	Def		def;
	PTGNode		tpdefs, structs, vars;
	POSITION	coord;

tpdefs = PTGTypeFileHead ();
structs = PTGEmpty ();
vars = TrInclVars (ae);

foreachinSEQDef (defseqOfAttrEval (ae), defs, def) {
	switch (typeof (def)) {
	case KSymb:
		TrSymbdef (DefToSymb (def), &tpdefs, &structs, &vars);
		break;
	case KProd:
		TrProddef (DefToProd (def), &tpdefs, &structs);
		break;
	case KTypedef:
		if (strlen (extnameOfTypedef (DefToTypedef(def))) != 0) {
		coord.line = rowOfDef (def);
		coord.col = colOfDef (def);
		message (WARNING, "old style: use C definition", 0, &coord);
		}
		break;
	default: break;
	}
}

PTGOutFile ("node.h", PTGFile (PTGSeq (tpdefs, structs)) _TERMINATOR);
PTGOutFile ("glattr.h", PTGFile (vars) _TERMINATOR);
}/*TrDefs*/


void TrSymbdef (sydef, ptpdefs, pstructs, pvars)
	Symb	sydef;
	PTGNode	*ptpdefs, *pstructs, *pvars;
{

(*pvars) = PTGSeq (*pvars, VarAttrDecls (attrsOfSymb (sydef)));

(*ptpdefs) = PTGSeq (*ptpdefs,
	PTGPtrTypedef (
		PTGSymbStructName (PTGAsIs (dnameOfSymb (sydef))),
		PTGSymbPtrTypeName (PTGAsIs (dnameOfSymb (sydef)))));

if (torntOfSymb (sydef) == SYMBNONT)
	(*pstructs) = PTGSeq (*pstructs,
		PTGStructDecl (
			PTGSymbStructName (PTGAsIs (dnameOfSymb (sydef))),
			TreeAttrDecls (attrsOfSymb (sydef))));
else	(*pstructs) = PTGSeq (*pstructs,
		PTGTermStructDecl (
			PTGSymbStructName (PTGAsIs (dnameOfSymb (sydef))),
			TreeAttrDecls (attrsOfSymb (sydef))));
}/*TrSymbdef*/


void TrProddef (prdef, ptpdefs, pstructs)
	Prod		prdef;
	PTGNode		*ptpdefs, *pstructs;
{	PTGNode		fields;
	SEQEntity	rhs;
	Entity		ent;
	int		sypos;
	char		*prodname;

prodname = GetBaseName (dnameOfProd (prdef));

(*ptpdefs) = PTGSeq (*ptpdefs,
	PTGPtrTypedef (
		PTGProdStructName (PTGAsIs (prodname)),
		PTGProdPtrTypeName (PTGAsIs (prodname))));

tmpDef = lookup_def (lhsOfProd (prdef));
fields = TreeAttrDecls (attrsOfSymb (DefToSymb (tmpDef)));

sypos = 1;
foreachinSEQEntity (rhsOfProd (prdef), rhs, ent) {
	if (typeof (ent) == KSymbol) {
		tmpDef = lookup_def (didOfSymbol (EntityToSymbol (ent)));
		fields = PTGSeq (fields,
		PTGDecl (
		PTGSymbPtrTypeName (
			PTGAsIs (dnameOfDef (tmpDef))),
		PTGDescName (PTGNumb (sypos++))));
	}
}

(*pstructs) = PTGSeq (*pstructs,
	PTGStructDecl (
		PTGProdStructName (PTGAsIs (prodname)),
		fields));

}/*TrProddef*/

